<script setup lang="ts">
import type { Receipt } from '@/types/Receipt'
import type { ReceiptItem } from '@/types/ReceiptItem'
import { useMemberStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'
import { inject, computed } from 'vue'
import { usePromotionStore } from '@/stores/promotion'
import { useAuthStore } from '@/stores/auth'

const promotionStore = usePromotionStore()
const receiptStore = useReceiptStore()
const memberStore = useMemberStore()
const authStore = useAuthStore() 


const pointuse = receiptStore.receipt!.pointUse


const totalToPay = computed(() => {
  return receiptStore.receipt!.totalPrice - receiptStore.receipt!.promotionDiscount
})
const props = defineProps<{
  modelValue: boolean
  receipt: Receipt
  receiptItems: ReceiptItem[]
}>()
const emit = defineEmits<{
  'update:modelValue': [boolean]
  save: []
}>()
const value = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})

function calculateItemAmount(item: any) {
  return item.unit * item.price
}
const changeAmount = inject('changeAmount')

const currentMemberId = computed(() => {
  const currentMember = memberStore.getCurrentMember()
  return currentMember ? currentMember.id : null
})


</script>

<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
    <template v-slot:activator="{ props }">
      <v-btn class="align-right" variant="plain" elevation="4" size="large" v-bind="props" rounded="xl"
        >ใบเสร็จ</v-btn>
    </template>
    <v-card>
      <v-row class="d-flex align-center justify-center">
        <v-col><v-img style="display: block; margin: auto" src="/img/logo/logo_name_black.png" alt="Logo"
            width="150px"></v-img></v-col>
      </v-row>

      <v-card-title class="text-h5"> ใบเสร็จ </v-card-title>
      <v-card-text>**************************************</v-card-text>
      <!-- <v-card-text style="text-align: left">Receipt No. {{ receipt.id }}</v-card-text> -->
      <v-card-text style="text-align: left; padding-top: 0">วันที่ : {{ receipt.createdDate ?
    receipt.createdDate.toLocaleDateString() : 'N/A' }}
        {{ receipt.createdDate ? receipt.createdDate.toLocaleTimeString() : 'N/A' }}</v-card-text>
      <v-card-text style="text-align: left; padding-top: 0">พนักงาน : {{ authStore.getCurrentUser()?.name }}</v-card-text>
      <v-card-text style="text-align: left; padding-top: 0">สาขา : {{ authStore.getCurrentUser()?.branch.name }}</v-card-text>
      <v-card-text style="text-align: left; padding-top: 0">สมาชิก : {{ receipt.member?.fristName }}</v-card-text>
      <v-card-text style="border: 2">---------------------------------------------</v-card-text>
      <v-row style="padding-bottom: 0">
        <v-col> รายการ </v-col>
        <v-col> จำนวน </v-col>
        <v-col> รวม </v-col>
      </v-row>
      <v-row style="padding-bottom: 0" v-for="(item, index) in receiptStore.receiptItems" :key="index">
        <v-col>{{ item.name }}{{ item.type }}<br />ขนาด: {{ item.size }} <br />ความหวาน:
          {{ item.sweet }}</v-col>
        <v-col>{{ item.unit }}</v-col>
        <v-col>{{ calculateItemAmount(item) }}</v-col>
      </v-row>
      <!-- <ReceiptDetailTable :editable="false"></ReceiptDetailTable> -->
      <span style="border: 0.1">---------------------------------------------</span>
      <v-card-text style="text-align: left; padding-top: 0">รวมทั้งสิ้น : {{ totalToPay }} บาท</v-card-text>
      <!-- <v-card-text style="text-align: left; padding-top: 0"
        >TOTAL AMOUNT : {{ receiptStore.receipt!.totalPrice }} บาท</v-card-text
      > -->
      <v-card-text style="text-align: left; padding-top: 0">วิธีชำระเงิน : {{ receiptStore.selectPaymentOption
        }}</v-card-text>
      <v-card-text style="text-align: left; padding-top: 0">เงินทอน : {{ receipt.change }} บาท</v-card-text>
      <v-card-text style="text-align: center; padding-top: 0">ขอบคุณที่ใช้บริการ</v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn style="background-color: transparent" variant="text" @click="receiptStore.receiptDialog = false">
          ยกเลิก
        </v-btn>
        <v-btn style="background-color: transparent" variant="text" @click="() => {
    ; (receiptStore.receiptDialog = false),
      // receiptStore.clear(),
      // memberStore.clear(),
      memberStore.clearFrom(),
      (receiptStore.paymentTypeDialog = false),
      (receiptStore.QRpaymentDialog = false),
    receiptStore.updateLastPrice(totalToPay)
    receiptStore.updateLastDiscount(receiptStore.receipt!.discount + receiptStore.receipt!.promotionDiscount)
    memberStore.updatePoints(currentMemberId!, pointuse);
    emit('save')
  }
    ">
          บันทึก
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-card-text {
  line-height: 1.5;
  padding-top: 8px;
  padding-bottom: 8px;
}

.v-dialog {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: rgba(0, 0, 0, 0.5);
  display: flex;
  justify-content: center;
  align-items: center;
}

.v-card {
  font-family: Georgia, 'Times New Roman', Times, serif;
  /* font-family: 'Athiti', sans-serif; */
  background: white;
  padding: 20x;
  border-radius: 15px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
  text-align: center;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
